<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible" >
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="账号" prop="accountCode">
        <el-input v-model="formData.accountCode" placeholder="请输入卡号" />
        <div class="flex flex-row items-center justify-center">
          <el-icon class="mr-2"><WarningFilled /></el-icon>
          <span class="text-orange-400">如果是数字货币，直接填数字货币的地址</span>
        </div>
      </el-form-item>
      <el-form-item label="配置ID" prop="configId">
        <el-select v-model="formData.configId">
          <el-option
            v-for="dict in channelConfigList"
            :key="dict.id"
            :label="dict.channelName"
            :value="dict.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="账户姓名" prop="accountName">
        <el-input v-model="formData.accountName" placeholder="请输入账户姓名" />
        <span>数字货币不需要输入</span>
      </el-form-item>
      <el-form-item label="银行名称" prop="bankName">
        <el-input v-model="formData.bankName" placeholder="请输入银行名称" />
        <span>数字货币不需要输入</span>
      </el-form-item>
      <el-form-item label="银行地址" prop="bankAddress">
        <el-input v-model="formData.bankAddress" placeholder="请输入银行地址" />
        <span>数字货币不需要输入</span>
      </el-form-item>

    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as ChannelApi from '@/api/member/channel'
import { ref } from 'vue'
import { WarningFilled } from "@element-plus/icons-vue";
import { getIntDictOptions } from "@/utils/dict";

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  accountCode: undefined,
  accountName: undefined,
  bankName: undefined,
  bankCountry: undefined,
  iban: undefined,
  bankAddress: undefined,
  branchName: undefined,
  branchAddress: undefined,
  configId: undefined
})
const formRules = reactive({
  accountCode: [{ required: true, message: '卡号不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
const channelConfigList = ref([])

/** 打开弹窗 */
const open = async (type: string, id?: number,configList:any) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  channelConfigList.value = configList
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ChannelApi.getChannel(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef.value) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ChannelApi.ChannelVO
    if (formType.value === 'create') {
      await ChannelApi.createChannel(data)
      message.success(t('common.createSuccess'))
    } else {
      await ChannelApi.updateChannel(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    accountCode: undefined,
    accountName: undefined,
    bankName: undefined,
    bankCountry: undefined,
    iban: undefined,
    bankAddress: undefined,
    branchName: undefined,
    branchAddress: undefined,
    configId: undefined
  }
  formRef.value?.resetFields()
}
</script>
